package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class LoadStateAndDetachEntityExample {
    static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");
    static EntityManager entityManager = entityManagerFactory.createEntityManager();

    public static void main(String[] args) {
        try {
            persistEmployee();
            Employee employee = findEmployeeById(1);
            displayInGui(employee);
        } finally {
            entityManagerFactory.close();
        }
    }

    private static void displayInGui(Employee employee) {
        System.out.println("-- displaying employee --");
        System.out.println(employee);
        employee.getPhones()
                .forEach(System.out::println);
    }

    private static Employee findEmployeeById(int id) {
        Employee employee = entityManager.find(Employee.class, id);
        //detach to remove it from entityManager cache
        entityManager.detach(employee);
        return employee;
    }

   private static void persistEmployee() {
        Employee employee = new Employee("Joe", "IT",
                Phone.cell("111-111-1111"), Phone.work("222-222-2222"));
        entityManager.getTransaction().begin();
        entityManager.persist(employee);
        entityManager.getTransaction().commit();
        //detach to remove it from entityManager cache
        entityManager.detach(employee);
    }
}